Index: lib/TWiki.pm
===================================================================
--- lib/TWiki.pm	(revision 1767)
+++ lib/TWiki.pm	(working copy)
@@ -1401,8 +982,7 @@
 
 =cut
 
-sub getTWikiLibDir
-{
+sub getTWikiLibDir {
     if( $twikiLibDir ) {
         return $twikiLibDir;
     }
@@ -1417,12 +997,25 @@
         }
     }
 
-    # fix relative path
+    # fix path relative to location of called script
     if( $twikiLibDir =~ /^\./ ) {
-        my $curr = cwd();
-        $twikiLibDir = "$curr/$twikiLibDir/";
+        writeWarning( "TWiki lib path is relative; you should make it absolute, otherwise some scripts may not run from the command line." );
+        my $bin;
+        if( $ENV{"SCRIPT_FILENAME"} &&
+            $ENV{"SCRIPT_FILENAME"} =~ /^(.+)\/[^\/]+$/ ) {
+            # CGI script name
+            $bin = $1;
+        } elsif ( $0 =~ /^(.*)\/.*?$/ ) {
+            # program name
+            $bin = $1;
+        } else {
+            # last ditch; relative to current directory.
+            eval 'use Cwd qw( cwd ); $bin = cwd();';
+        }
+        $twikiLibDir = "$bin/$twikiLibDir/";
         # normalize "/../" and "/./"
-        while ( $twikiLibDir =~ s|([\\/])[^\\/]+[\\/]\.\.[\\/]|$1| ) {};
+        while ( $twikiLibDir =~ s|([\\/])[^\\/]+[\\/]\.\.[\\/]|$1| ) {
+        };
         $twikiLibDir =~ s|([\\/])\.[\\/]|$1|g;
     }
     $twikiLibDir =~ s|([\\/])[\\/]*|$1|g; # reduce "//" to "/"
@@ -1431,130 +1024,34 @@
     return $twikiLibDir;
 }
 
-# =========================
 =pod
 
----++ sub revDate2EpSecs ()
+---++ getSkin ()
 
-Not yet documented.
+Get the name of the currently requested skin
 
 =cut
 
-sub revDate2EpSecs
-# Convert RCS revision date/time to seconds since epoch, for easier sorting 
-{
-    my( $date ) = @_;
-    # NOTE: This routine *will break* if input is not one of below formats!
-    
-    # FIXME - why aren't ifs around pattern match rather than $5 etc
-    # try "31 Dec 2001 - 23:59"  (TWiki date)
-    if ($date =~ /([0-9]+)\s+([A-Za-z]+)\s+([0-9]+)[\s\-]+([0-9]+)\:([0-9]+)/) {
-        my $year = $3;
-        $year -= 1900 if( $year > 1900 );
-        return timegm( 0, $5, $4, $1, $mon2num{$2}, $year );
-    }
-
-    # try "2001/12/31 23:59:59" or "2001.12.31.23.59.59" (RCS date)
-    if ($date =~ /([0-9]+)[\.\/\-]([0-9]+)[\.\/\-]([0-9]+)[\.\s\-]+([0-9]+)[\.\:]([0-9]+)[\.\:]([0-9]+)/) {
-        my $year = $1;
-        $year -= 1900 if( $year > 1900 );
-        return timegm( $6, $5, $4, $3, $2-1, $year );
-    }
-
-    # try "2001/12/31 23:59" or "2001.12.31.23.59" (RCS short date)
-    if ($date =~ /([0-9]+)[\.\/\-]([0-9]+)[\.\/\-]([0-9]+)[\.\s\-]+([0-9]+)[\.\:]([0-9]+)/) {
-        my $year = $1;
-        $year -= 1900 if( $year > 1900 );
-        return timegm( 0, $5, $4, $3, $2-1, $year );
-    }
-
-    # try "2001-12-31T23:59:59Z" or "2001-12-31T23:59:59+01:00" (ISO date)
-    # FIXME: Calc local to zulu time "2001-12-31T23:59:59+01:00"
-    if ($date =~ /([0-9]+)\-([0-9]+)\-([0-9]+)T([0-9]+)\:([0-9]+)\:([0-9]+)/ ) {
-        my $year = $1;
-        $year -= 1900 if( $year > 1900 );
-        return timegm( $6, $5, $4, $3, $2-1, $year );
-    }
-
-    # try "2001-12-31T23:59Z" or "2001-12-31T23:59+01:00" (ISO short date)
-    # FIXME: Calc local to zulu time "2001-12-31T23:59+01:00"
-    if ($date =~ /([0-9]+)\-([0-9]+)\-([0-9]+)T([0-9]+)\:([0-9]+)/ ) {
-        my $year = $1;
-        $year -= 1900 if( $year > 1900 );
-        return timegm( 0, $5, $4, $3, $2-1, $year );
-    }
-
-    # give up, return start of epoch (01 Jan 1970 GMT)
-    return 0;
-}
-
-# =========================
-=pod
-
----++ sub getSessionValue ()
-
-Not yet documented.
-
-=cut
-
-sub getSessionValue
-{
-#   my( $key ) = @_;
-    return &TWiki::Plugins::getSessionValueHandler( @_ );
-}
-
-# =========================
-=pod
-
----++ sub setSessionValue ()
-
-Not yet documented.
-
-=cut
-
-sub setSessionValue
-{
-#   my( $key, $value ) = @_;
-    return &TWiki::Plugins::setSessionValueHandler( @_ );
-}
-
-# =========================
-=pod
-
----++ sub getSkin ()
-
-Not yet documented.
-
-=cut
-
-sub getSkin
-{
+sub getSkin {
     my $skin = "";
     $skin = $cgiQuery->param( 'skin' ) if( $cgiQuery );
-    $skin = &TWiki::Prefs::getPreferencesValue( "SKIN" ) unless( $skin );
+    $skin = TWiki::Prefs::getPreferencesValue( "SKIN" ) unless( $skin );
     return $skin;
 }
 
-# =========================
 =pod
 
----++ sub getViewUrl (  $web, $topic  )
+---++ getViewUrl (  $web, $topic  )
 
-Returns a fully-qualified URL to the specified topic, which must be normalized
-into separate specified =$web= and =$topic= parts.
+Returns a fully-qualified URL to the specified topic.
 
 =cut
 
-sub getViewUrl
-{
+sub getViewUrl {
     my( $theWeb, $theTopic ) = @_;
-    # PTh 20 Jun 2000: renamed sub viewUrl to getViewUrl, added $theWeb
-    # WM 14 Feb 2004: Removed support for old syntax not specifying $theWeb
 
     $theTopic =~ s/\s*//gs; # Illegal URL, remove space
 
-    # PTh 24 May 2000: added $urlHost, needed for some environments
-    # see also Codev.PageRedirectionNotWorking
     return "$urlHost$dispScriptUrlPath$dispViewPath$scriptSuffix/$theWeb/$theTopic";
 }
 
@@ -1569,8 +1066,7 @@
 
 =cut
 
-sub getScriptUrl
-{
+sub getScriptUrl {
     my( $theWeb, $theTopic, $theScript ) = @_;
     
     my $url = "$urlHost$dispScriptUrlPath/$theScript$scriptSuffix/$theWeb/$theTopic";
@@ -1593,11 +1089,9 @@
 
 =cut
 
-sub getOopsUrl
-{
+sub getOopsUrl {
     my( $theWeb, $theTopic, $theTemplate,
         $theParam1, $theParam2, $theParam3, $theParam4 ) = @_;
-    # PTh 20 Jun 2000: new sub
     my $web = $webName;  # current web
     if( $theWeb ) {
         $web = $theWeb;
@@ -1606,98 +1100,51 @@
     # $urlHost is needed, see Codev.PageRedirectionNotWorking
     $url = getScriptUrl( $web, $theTopic, "oops" );
     $url .= "\?template=$theTemplate";
-    $url .= "\&amp;param1=" . handleUrlEncode( $theParam1 ) if ( $theParam1 );
-    $url .= "\&amp;param2=" . handleUrlEncode( $theParam2 ) if ( $theParam2 );
-    $url .= "\&amp;param3=" . handleUrlEncode( $theParam3 ) if ( $theParam3 );
-    $url .= "\&amp;param4=" . handleUrlEncode( $theParam4 ) if ( $theParam4 );
+    $url .= "\&amp;param1=" . _urlEncode( $theParam1 ) if ( $theParam1 );
+    $url .= "\&amp;param2=" . _urlEncode( $theParam2 ) if ( $theParam2 );
+    $url .= "\&amp;param3=" . _urlEncode( $theParam3 ) if ( $theParam3 );
+    $url .= "\&amp;param4=" . _urlEncode( $theParam4 ) if ( $theParam4 );
 
     return $url;
 }
 
-# =========================
 =pod
 
----++ sub makeTopicSummary (  $theText, $theTopic, $theWeb, $theFlags )
+---++ normalizeWebTopicName (  $theWeb, $theTopic  )
 
-Not yet documented.
+Normalize a Web.TopicName
+<pre>
+Input:                      Return:
+  ( "Web",  "Topic" )         ( "Web",  "Topic" )
+  ( "",     "Topic" )         ( "Main", "Topic" )
+  ( "",     "" )              ( "Main", "WebHome" )
+  ( "",     "Web/Topic" )     ( "Web",  "Topic" )
+  ( "",     "Web.Topic" )     ( "Web",  "Topic" )
+  ( "Web1", "Web2.Topic" )    ( "Web2", "Topic" )
+</pre>
+Note: Function renamed from getWebTopic
 
 =cut
 
-sub makeTopicSummary
-{
-    my( $theText, $theTopic, $theWeb, $theFlags ) = @_;
-    # called by search, mailnotify & changes after calling readFileHead
+sub normalizeWebTopicName {
+   my( $theWeb, $theTopic ) = @_;
 
-    my $htext = $theText;
-    $theFlags = "" unless( $theFlags );
-    # Format e-mail to add spam padding (HTML tags removed later)
-    $htext =~ s/([\s\(])(?:mailto\:)*([a-zA-Z0-9\-\_\.\+]+)\@([a-zA-Z0-9\-\_\.]+)\.([a-zA-Z0-9\-\_]+)(?=[\s\.\,\;\:\!\?\)])/$1 . &TWiki::Render::mailtoLink( $2, $3, $4 )/ge;
-    $htext =~ s/<\!\-\-.*?\-\->//gs;  # remove all HTML comments
-    $htext =~ s/<\!\-\-.*$//s;        # cut HTML comment
-    $htext =~ s/<[^>]*>//g;           # remove all HTML tags
-    $htext =~ s/\&[a-z]+;/ /g;        # remove entities
-    $htext =~ s/%WEB%/$theWeb/g;      # resolve web
-    $htext =~ s/%TOPIC%/$theTopic/g;  # resolve topic
-    $htext =~ s/%WIKITOOLNAME%/$wikiToolName/g; # resolve TWiki tool name
-    $htext =~ s/%META:[A-Z].*?}%//g;  # remove meta data variables
-    if( $theFlags =~ /nohead/ ) {
-        # skip headings on top
-        while( $htext =~ s/^\s*\-\-\-+\+[^\n\r]+// ) {}; # remove heading
-    }
-    unless( $theFlags =~ /showvar/ ) {
-        # remove variables
-        $htext =~ s/%[A-Z_]+%//g;     # remove %VARS%
-        $htext =~ s/%[A-Z_]+{.*?}%//g;# remove %VARS{}%
-    }
-    $htext =~ s/\[\[([^\]]*\]\[|[^\s]*\s)(.*?)\]\]/$2/g; # keep only link text of [[][]]
-    $htext =~ s/[\%\[\]\*\|=_\&\<\>\$]/ /g;              # remove Wiki formatting chars & defuse %VARS%
-    $htext =~ s/\-\-\-+\+*\s*\!*/ /g; # remove heading formatting
-    $htext =~ s/\s+[-\+]*/ /g;        # remove newlines and special chars
-    $htext =~ s/^\s+/ /;              # remove leading spaces
-    $htext =~ s/\s+$/ /;              # remove trailing spaces
+   if( $theTopic =~ m|^([^.]+)[\.\/](.*)$| ) {
+       $theWeb = $1;
+       $theTopic = $2;
+   }
+   $theWeb = $TWiki::webName unless( $theWeb );
+   $theTopic = $TWiki::topicName unless( $theTopic );
 
-    # FIXME I18N: Avoid splitting within multi-byte characters (e.g. EUC-JP
-    # encoding) by encoding bytes as Perl UTF-8 characters in Perl 5.8+. 
-    # This avoids splitting within a Unicode codepoint (or a UTF-16
-    # surrogate pair, which is encoded as a single Perl UTF-8 character),
-    # but we ideally need to avoid splitting closely related Unicode codepoints.
-    # Specifically, this means Unicode combining character sequences (e.g.
-    # letters and accents) - might be better to split on word boundary if
-    # possible.
-
-    # limit to n chars
-    my $nchar = $theFlags;
-    unless( $nchar =~ s/^.*?([0-9]+).*$/$1/ ) {
-        $nchar = 162;
-    }
-    $nchar = 16 if( $nchar < 16 );
-    $htext =~ s/(.{$nchar})($regex{mixedAlphaNumRegex})(.*?)$/$1$2 \.\.\./;
-
-    # Encode special chars into XML &#nnn; entities for use in RSS feeds
-    # - no encoding for HTML pages, to avoid breaking international 
-    # characters. FIXME: Only works for ISO-8859-1 characters, where the
-    # Unicode encoding (&#nnn;) is identical.
-    if( $pageMode eq 'rss' ) {
-	# FIXME: Issue for EBCDIC/UTF-8
-	$htext =~ s/([\x7f-\xff])/"\&\#" . unpack( "C", $1 ) .";"/ge;
-    }
-
-    # prevent text from getting rendered in inline search and link tool 
-    # tip text by escaping links (external, internal, Interwiki)
-    $htext =~ s/([\s\(])(?=\S)/$1<nop>/g;
-    $htext =~ s/([\-\*\s])($regex{linkProtocolPattern}\:)/$1<nop>$2/go;
-    $htext =~ s/@([a-zA-Z0-9\-\_\.]+)/@<nop>$1/g;	# email address
-
-    return $htext;
+   return( $theWeb, $theTopic );
 }
 
-# =========================
 =pod
 
----++ sub extractParameters (  $str )
+---++ extractParameters (  $str )
 
 Extracts parameters from a variable string and returns a hash with all parameters.
-The nameless parameter's key is _DEFAULT.
+The nameless parameter key is _DEFAULT.
 
    * Example variable: %TEST{ "nameless" name1="val1" name2="val2" }%
    * First extract text between {...} to get: "nameless" name1="val1" name2="val2"
@@ -1710,8 +1157,7 @@
 
 =cut
 
-sub extractParameters
-{
+sub extractParameters {
     my( $str ) = @_;
 
     my %params = ();
@@ -1741,17 +1187,19 @@
     return map{ s/\\$TranslationToken/\"/go; $_ } %params;
 }
 
-# =========================
 =pod
 
----++ sub extractNameValuePair (  $str, $name  )
+---++ extractNameValuePair (  $str, $name  )
 
-Not yet documented.
+Extract a named or unnamed value from a variable parameter string
+Function extractParameters is more efficient for extracting several parameters
+| =$attr= | Attribute string |
+| =$name= | Name, optional |
+| Return: =$value=   | Extracted value |
 
 =cut
 
-sub extractNameValuePair
-{
+sub extractNameValuePair {
     my( $str, $name ) = @_;
 
     my $value = "";
@@ -1786,33 +1234,14 @@
     return $value;
 }
 
-# =========================
-=pod
-
----++ sub fixN (  $theTag  )
-
-Not yet documented.
-
-=cut
-
-sub fixN
-{
+sub _fixN {
     my( $theTag ) = @_;
     $theTag =~ s/[\r\n]+//gs;
     return $theTag;
 }
 
-# =========================
-=pod
-
----++ sub fixURL (  $theHost, $theAbsPath, $theUrl  )
-
-Not yet documented.
-
-=cut
-
-sub fixURL
-{
+# Convert relative URLs to absolute URIs
+sub __fixURL {
     my( $theHost, $theAbsPath, $theUrl ) = @_;
 
     my $url = $theUrl;
@@ -1822,7 +1251,7 @@
     } elsif( $url =~ /^\./ ) {
         # fix relative URL
         $url = "$theHost$theAbsPath/$url";
-    } elsif( $url =~ /^$regex{linkProtocolPattern}\:/ ) {
+    } elsif( $url =~ /^$regex{linkProtocolPattern}\:/o ) {
         # full qualified URL, do nothing
     } elsif( $url ) {
         # FIXME: is this test enough to detect relative URLs?
@@ -1832,48 +1261,25 @@
     return $url;
 }
 
-# =========================
-=pod
-
----++ sub fixIncludeLink (  $theWeb, $theLink, $theLabel  )
-
-Not yet documented.
-
-=cut
-
-sub fixIncludeLink
-{
+sub _fixIncludeLink {
     my( $theWeb, $theLink, $theLabel ) = @_;
 
-    if( $theLabel ) {
-        # [[...][...]] link
-        if( $theLink =~ /^($regex{webNameRegex}\.|$regex{defaultWebNameRegex}\.|$regex{linkProtocolPattern}\:)/ ) {
-            return "[[$theLink][$theLabel]]";  # no change
+    # [[...][...]] link
+    if( $theLink =~ /^($regex{webNameRegex}\.|$regex{defaultWebNameRegex}\.|$regex{linkProtocolPattern}\:)/o ) {
+        if ( $theLabel ) {
+            return "[[$theLink][$theLabel]]";
+        } else {
+            return "[[$theLink]]";
         }
-        # add 'Web.' prefix
+    } elsif ( $theLabel ) {
         return "[[$theWeb.$theLink][$theLabel]]";
-
     } else {
-        # [[...]] link
-        if( $theLink =~ /^($regex{webNameRegex}\.|$regex{defaultWebNameRegex}\.|$regex{linkProtocolPattern}\:)/ ) {
-            return "[[$theLink]]";  # no change
-        }
-        # add 'Web.' prefix
         return "[[$theWeb.$theLink][$theLink]]";
     }
 }
 
-# =========================
-=pod
-
----++ sub cleanupIncludedHTML ( $text, $host, $path )
-
-Clean-up HTML text so that it can be shown embedded in a topic
-
-=cut
-
-sub cleanupIncludedHTML
-{
+# Clean-up HTML text so that it can be shown embedded in a topic
+sub _cleanupIncludedHTML {
     my( $text, $host, $path ) = @_;
 
     # FIXME: Make aware of <base> tag
@@ -1883,23 +1289,21 @@
     $text =~ s/^.*?<body[^>]*>//is;         # remove all to <BODY>
     $text =~ s/(?:\n)<\/body>//is;          # remove </BODY>
     $text =~ s/(?:\n)<\/html>//is;          # remove </HTML>
-    $text =~ s/(<[^>]*>)/&fixN($1)/ges;     # join tags to one line each
-    $text =~ s/(\s(href|src|action)\=[\"\']?)([^\"\'\>\s]*)/$1 . &fixURL( $host, $path, $3 )/geois;
+    $text =~ s/(<[^>]*>)/&_fixN($1)/ges;     # join tags to one line each
+    $text =~ s/(\s(href|src|action)\=[\"\']?)([^\"\'\>\s]*)/$1 . &_fixURL( $host, $path, $3 )/geois;
 
     return $text;
 }
 
-# =========================
 =pod
 
----++ sub applyPatternToIncludedText (  $theText, $thePattern )
+---++ applyPatternToIncludedText (  $theText, $thePattern )
 
 Apply a pattern on included text to extract a subset
 
 =cut
 
-sub applyPatternToIncludedText
-{
+sub applyPatternToIncludedText {
     my( $theText, $thePattern ) = @_;
     $thePattern =~ s/([^\\])([\$\@\%\&\#\'\`\/])/$1\\$2/g;  # escape some special chars
     $thePattern =~ /(.*)/;     # untaint
@@ -1908,17 +1312,27 @@
     return $theText;
 }
 
-# =========================
-=pod
+sub _handleFORMFIELD {
+    return TWiki::Render::renderFormField( @_ );
+}
 
----++ sub handleIncludeUrl (  $theUrl, $thePattern )
+sub _handleTMPLP {
+    my $params = shift;
+    return TWiki::Templates::expandTemplate( $params->{_DEFAULT} );
+}
 
-Not yet documented.
+sub _handleVAR {
+    my $params = shift;
+    return TWiki::Prefs::getWebVariable( $params->{_DEFAULT} );
+}
 
-=cut
+sub _handlePLUGINVERSION {
+    my $params = shift;
+    TWiki::Plugins::getPluginVersion( $params->{_DEFAULT} );
+}
 
-sub handleIncludeUrl
-{
+# Fetch content from a URL for includion by an INCLUDE
+sub _includeUrl {
     my( $theUrl, $thePattern, $theWeb, $theTopic ) = @_;
     my $text = "";
     my $host = "";
@@ -1934,51 +1348,38 @@
         my $fileName = "$pubDir/$web/$topic/$3";
         if( $fileName =~ m/\.(txt|html?)$/i ) {       # FIXME: Check for MIME type, not file suffix
             unless( -e $fileName ) {
-                return showError( "Error: File attachment at $theUrl does not exist" );
+                return _inlineError( "Error: File attachment at $theUrl does not exist" );
             }
             if( "$web.$topic" ne "$theWeb.$theTopic" ) {
                 # CODE_SMELL: Does not account for not yet authenticated user
                 unless( TWiki::Access::checkAccessPermission( "VIEW", $wikiUserName, "", $topic, $web ) ) {
-                    return showError( "Error: No permission to view files attached to $web.$topic" );
+                    return _inlineError( "Error: No permission to view files attached to $web.$topic" );
                 }
             }
             $text = TWiki::Store::readFile( $fileName );
-            $text = cleanupIncludedHTML( $text, $urlHost, $pubUrlPath );
+            $text = _cleanupIncludedHTML( $text, $urlHost, $pubUrlPath );
             $text = applyPatternToIncludedText( $text, $thePattern ) if( $thePattern );
             return $text;
         }
         # fall through; try to include file over http based on MIME setting
     }
 
-    # RNF 22 Jan 2002 Handle http://user:pass@host
     if( $theUrl =~ /http\:\/\/(.+)\:(.+)\@([^\:]+)\:([0-9]+)(\/.*)/ ) {
-        $user = $1;
-        $pass = $2;
-        $host = $3;
-        $port = $4;
-        $path = $5;
-
+        ( $user, $pass, $host, $port, $path ) = ( $1, $2, $3, $4, $5 );
     } elsif( $theUrl =~ /http\:\/\/(.+)\:(.+)\@([^\/]+)(\/.*)/ ) {
-        $user = $1;
-        $pass = $2;
-        $host = $3;
-        $path = $4;
-
+        ( $user, $pass, $host, $path ) = ( $1, $2, $3, $4 );
     } elsif( $theUrl =~ /http\:\/\/([^\:]+)\:([0-9]+)(\/.*)/ ) {
-        $host = $1;
-        $port = $2;
-        $path = $3;
-
+        ( $host, $port, $path ) = ( $1, $2, $3 );
     } elsif( $theUrl =~ /http\:\/\/([^\/]+)(\/.*)/ ) {
-        $host = $1;
-        $path = $2;
-
+        ( $host, $path ) = ( $1, $2 );
     } else {
-        $text = showError( "Error: Unsupported protocol. (Must be 'http://domain/...')" );
+        $text = _inlineError( "Error: Unsupported protocol. (Must be 'http://domain/...')" );
         return $text;
     }
 
-    $text = &TWiki::Net::getUrl( $host, $port, $path, $user, $pass );
+    use TWiki::Net;       # SMTP, get URL
+
+    $text = TWiki::Net::getUrl( $host, $port, $path, $user, $pass );
     $text =~ s/\r\n/\n/gs;
     $text =~ s/\r/\n/gs;
     $text =~ s/^(.*?\n)\n(.*)/$2/s;
@@ -1993,13 +1394,13 @@
         if( $port != 80 ) {
             $host .= ":$port";
         }
-        $text = cleanupIncludedHTML( $text, $host, $path );
+        $text = _cleanupIncludedHTML( $text, $host, $path );
 
     } elsif( $contentType =~ /^text\/(plain|css)/ ) {
         # do nothing
 
     } else {
-        $text = showError( "Error: Unsupported content type: $contentType."
+        $text = _inlineError( "Error: Unsupported content type: $contentType."
               . " (Must be text/html, text/plain or text/css)" );
     }
 
@@ -2008,36 +1409,32 @@
     return $text;
 }
 
-=pod
+# Processes a specific instance %<nop>INCLUDE{...}% syntax.
+# Returns the text to be inserted in place of the INCLUDE command.
+# $topic and $web should be for the immediate parent topic in the
+# include hierarchy. Works for both URLs and absolute server paths.
+# 
+# \@verbatim is a buffer for storing removed verbatim blocks.
+# It is optional.
+# 
+# \%theProcessedTopics is a hash of topics already %<nop>INCLUDE%'ed.
+# These are not allowed to be included again to prevent infinte recursive
+# inclusion. It is optional (will be created on demand).
+sub _handleINCLUDE {
+    my ( $params, $theTopic, $theWeb, $verbatim, $theProcessedTopics ) = @_;
 
----++ handleIncludeFile( $includeCommandAttribs, $topic, $web, \@verbatimBuffer, @processedTopics )
-Return value: $includedText
+    my $incfile = $params->{_DEFAULT};
+    my $pattern = $params->{pattern};
+    my $rev     = $params->{rev};
+    my $warn    = $params->{warn};
 
-Processes a specific instance %<nop>INCLUDE{...}% syntax.  Returns the text to be
-inserted in place of the INCLUDE command.  $topic and $web should be for the
-immediate parent topic in the include hierarchy. @verbatimBuffer is the request-
-global buffer for storing removed verbatim blocks, and @processedTopics is a
-list of topics already %<nop>INCLUDE%'ed -- these are not allowed to be included
-again to prevent infinte recursive inclusion.
-
-=cut
-
-sub handleIncludeFile
-{
-    my( $theAttributes, $theTopic, $theWeb, $verbatim, @theProcessedTopics ) = @_;
-
-    my %params  = extractParameters( $theAttributes );
-    my $incfile = $params{"_DEFAULT"} || "";
-    my $pattern = $params{"pattern"}  || "";
-    my $rev     = $params{"rev"}      || "";
-    my $warn    = $params{"warn"}     || "";
-
     if( $incfile =~ /^http\:/ ) {
         # include web page
-        return handleIncludeUrl( $incfile, $pattern, $theWeb, $theTopic );
+        return _includeUrl( $incfile, $pattern, $theWeb, $theTopic );
     }
 
-    # CrisBailiff, PeterThoeny 12 Jun 2000: Add security
+    $theProcessedTopics = {} unless $theProcessedTopics;
+
     $incfile =~ s/$securityFilter//go;    # zap anything suspicious
     if( $doSecureInclude ) {
         # Filter out ".." from filename, this is to
@@ -2070,7 +1467,7 @@
         # give up, file not found
         $warn = TWiki::Prefs::getPreferencesValue( "INCLUDEWARNING" ) unless( $warn );
         if( $warn =~ /^on$/i ) {
-            return showError( "Warning: Can't INCLUDE <nop>$incfile, topic not found" );
+            return _inlineError( "Warning: Can't INCLUDE <nop>$incfile, topic not found" );
         } elsif( $warn && $warn !~ /^(off|no)$/i ) {
             $incfile =~ s/\//\./go;
             $warn =~ s/\$topic/$incfile/go;
@@ -2080,22 +1477,22 @@
     }
 
     # prevent recursive loop
-    if( ( @theProcessedTopics ) && ( grep { /^$fileName$/ } @theProcessedTopics ) ) {
+    if( $theProcessedTopics->{$fileName} ) {
         # file already included
         if( $warn || TWiki::Prefs::getPreferencesFlag( "INCLUDEWARNING" ) ) {
             unless( $warn =~ /^(off|no)$/i ) {
-                return showError( "Warning: Can't INCLUDE <nop>$incfile twice, topic is already included" );
+                return _inlineError( "Warning: Can't INCLUDE <nop>$incfile twice, topic is already included" );
             }
         }
         return "";
     } else {
         # remember for next time
-        push( @theProcessedTopics, $fileName );
+        $theProcessedTopics->{$fileName} = 1;
     }
 
     # set include web/filenames and current web/filenames
-    $includingWebName = $theWeb;
-    $includingTopicName = $theTopic;
+    $sessionInternalTags{INCLUDINGWEB} = $theWeb;
+    $sessionInternalTags{INCLUDINGTOPIC} = $theTopic;
     if( $fileName =~ s/\/([^\/]*)\/([^\/]*)\.txt$/$1/ ) {
         # identified "/Web/TopicName.txt" filename, e.g. a Wiki topic
         # so save the current web and topic name
@@ -2105,9 +1502,9 @@
 
         if( $rev ) {
             $rev = "1.$rev" unless( $rev =~ /^1\./ );
-            ( $meta, $text ) = &TWiki::Store::readTopicVersion( $theWeb, $theTopic, $rev );
+            ( $meta, $text ) = TWiki::Store::readTopicVersion( $theWeb, $theTopic, $rev );
         } else {
-            ( $meta, $text ) = &TWiki::Store::readTopic( $theWeb, $theTopic );
+            ( $meta, $text ) = TWiki::Store::readTopic( $theWeb, $theTopic );
         }
         # remove everything before %STARTINCLUDE% and after %STOPINCLUDE%
         $text =~ s/.*?%STARTINCLUDE%//s;
@@ -2117,73 +1514,81 @@
 
     $text = applyPatternToIncludedText( $text, $pattern ) if( $pattern );
 
-    # handle all preferences and internal tags (for speed: call by reference)
-    $text = takeOutVerbatim( $text, $verbatim );
+    # handle all preferences and internal tags
+    $text = TWiki::Render::takeOutBlocks( $text, "verbatim", $verbatim );
 
     # Escape rendering: Change " !%VARIABLE%" to " %<nop>VARIABLE%", for final " %VARIABLE%" output
     $text =~ s/(\s)\!\%([A-Z])/$1%<nop>$2/g;
 
-    # handle all preferences and internal tags
-    &TWiki::Prefs::handlePreferencesTags( $text );
-    handleInternalTags( $text, $theTopic, $theWeb );
+    processTags( \$text, $theTopic, $theWeb,
+                        $verbatim, $theProcessedTopics );
 
-    # TWiki Plugin Hook (4th parameter tells plugin that its called from an include)
-    &TWiki::Plugins::commonTagsHandler( $text, $theTopic, $theWeb, 1 );
+    # 4th parameter tells plugin that its called from an include
+    TWiki::Plugins::commonTagsHandler( $text, $theTopic, $theWeb, 1 );
 
-    # handle tags again because of plugin hook
-    &TWiki::Prefs::handlePreferencesTags( $text );
-    handleInternalTags( $text, $theTopic, $theWeb );
-
-    # If needed, fix all "TopicNames" to "Web.TopicNames" to get the right context
+    # If needed, fix all "TopicNames" to "Web.TopicNames" to get the
+    # right context
+    # SMELL: This is a hack.
     if( ( $isTopic ) && ( $theWeb ne $webName ) ) {
         # "TopicName" to "Web.TopicName"
         $text =~ s/(^|[\s\(])($regex{webNameRegex}\.$regex{wikiWordRegex})/$1$TranslationToken$2/go;
         $text =~ s/(^|[\s\(])($regex{wikiWordRegex})/$1$theWeb\.$2/go;
         $text =~ s/(^|[\s\(])$TranslationToken/$1/go;
         # "[[TopicName]]" to "[[Web.TopicName][TopicName]]"
-        $text =~ s/\[\[([^\]]+)\]\]/fixIncludeLink( $theWeb, $1 )/geo;
+        $text =~ s/\[\[([^\]]+)\]\]/&_fixIncludeLink( $theWeb, $1 )/geo;
         # "[[TopicName][...]]" to "[[Web.TopicName][...]]"
-        $text =~ s/\[\[([^\]]+)\]\[([^\]]+)\]\]/fixIncludeLink( $theWeb, $1, $2 )/geo;
+        $text =~ s/\[\[([^\]]+)\]\[([^\]]+)\]\]/&_fixIncludeLink( $theWeb, $1, $2 )/geo;
         # FIXME: Support for <noautolink>
     }
-    
-    # FIXME What about attachments?
 
-    # recursively process multiple embedded %INCLUDE% statements and prefs
-    $text =~ s/%INCLUDE{(.*?)}%/&handleIncludeFile($1, $theTopic, $theWeb, $verbatim, @theProcessedTopics )/ge;
+    # handle tags again because of plugin hook
+    processTags( \$text, $theTopic, $theWeb,
+                        $verbatim, $theProcessedTopics );
 
+    $text =~ s/^\n+/\n/;
+    $text =~ s/\n+$/\n/;
+
+    # FIXME What about attachments?
+
     return $text;
 }
 
-# =========================
-# Only does simple search for topicmoved at present, can be expanded when required
-=pod
+sub _handleHTTP_HOST {
+    return $ENV{HTTP_HOST};
+}
 
----++ sub handleMetaSearch (  $attributes  )
+sub _handleREMOTE_ADDR {
+    return $ENV{REMOTE_ADDR};
+}
 
-Not yet documented.
+sub _handleREMOTE_PORT {
+    return $ENV{REMOTE_PORT};
+}
 
-=cut
+sub _handleREMOTE_USER {
+    return $ENV{REMOTE_USER};
+}
 
-sub handleMetaSearch
-{
-    my( $theAttributes ) = @_;
+# Only does simple search for topicmoved at present, can be expanded when required
+# SMELL: this violates encapsulation of Store and Meta, by exporting
+# the assumption that meta-data is stored embedded inside topic
+# text.
+sub _handleMETASEARCH {
+    my $params = shift;
+    my $attrWeb           = $params->{web};
+    my $attrTopic         = $params->{topic};
+    my $attrType          = $params->{type};
+    my $attrTitle         = $params->{title};
+    my $attrDefault       = $params->{default};
 
-    my %params      = extractParameters( $theAttributes );
-    my $attrWeb     = $params{"web"}     || "";
-    my $attrTopic   = $params{"topic"}   || "";
-    my $attrType    = $params{"type"}    || "";
-    my $attrTitle   = $params{"title"}   || "";
-    my $attrDefault = $params{"default"} || "";
-
     my $searchVal = "XXX";
-    
+
     if( ! $attrType ) {
        $attrType = "";
     }
 
     my $searchWeb = "all";
-    
+
     if( $attrType eq "topicmoved" ) {
        $searchVal = "%META:TOPICMOVED[{].*from=\\\"$attrWeb\.$attrTopic\\\".*[}]%";
     } elsif ( $attrType eq "parent" ) {
@@ -2191,8 +1596,10 @@
        $searchVal = "%META:TOPICPARENT[{].*name=\\\"($attrWeb\\.)?$attrTopic\\\".*[}]%";
     }
 
-    my $text = &TWiki::Search::searchWeb(
-        "inline"        => "1",
+    use TWiki::Search;    # search engine
+
+    my $text = TWiki::Search::searchWeb(
+        #"_callback"    => undef,
         "search"        => $searchVal,
         "web"           => $searchWeb,
         "type"          => "regex",
@@ -2212,79 +1619,35 @@
     return $text;
 }
 
-# =========================
-=pod
+# Deprecated, but used in signatures
+sub _handleDATE {
+    return formatTime(time(), "\$day \$mon \$year", "gmtime");
+}
 
----++ sub handleSearchWeb ( $attributes, $baseWeb, $baseTopic )
+sub _handleGMTIME {
+    my $params = shift;
+    return formatTime( time(), $params->{_DEFAULT}, "gmtime" );
+}
 
-Not yet documented.
-
-=cut
-
-sub handleSearchWeb
-{
-    my( $attributes, $baseWeb, $baseTopic ) = @_;
-
-    my %params = extractParameters( $attributes );     # pass along all attributes
-    $params{"inline"} = 1;                             # and add some more
-    $params{"baseweb"} = $baseWeb;
-    $params{"basetopic"} = $baseTopic;
-    $params{"search"} = $params{"_DEFAULT"} if( $params{"_DEFAULT"} );
-    $params{"type"} = TWiki::Prefs::getPreferencesValue( "SEARCHVARDEFAULTTYPE" ) unless( $params{"type"} );
-
-    return TWiki::Search::searchWeb( %params );
+sub _handleSERVERTIME {
+    my $params = shift;
+    return formatTime( time(), $params->{_DEFAULT}, "servertime" );
 }
 
-# =========================
-#TODO: this seems like a duplication with formatGmTime and formatLocTime
-#remove any 2.
-=pod
-
----++ sub handleTime (  $theAttributes, $theZone  )
-
-Not yet documented.
-
-=cut
-
-sub handleTime
-{
-    my( $theAttributes, $theZone ) = @_;
-    # format examples:
-    #   28 Jul 2000 15:33:59 is "$day $month $year $hour:$min:$sec"
-    #   001128               is "$ye$mo$day"
-
-    my $format = extractNameValuePair( $theAttributes );
-
-    my $value = "";
-    my $time = time();
-
-#    if( $format ) {
-        $value = formatTime($time, $format, $theZone);
- #   } else {
- #       if( $theZone eq "gmtime" ) {
- #           $value = gmtime( $time );
- #       } elsif( $theZone eq "servertime" ) {
- #           $value = localtime( $time );
- #       }
- #   }
-
-#    if( $theZone eq "gmtime" ) {
-#		$value = $value." GMT";
-#	}
-
-    return $value;
+sub _handleDISPLAYTIME {
+    my $params = shift;
+    return formatTime( time(), $params->{_DEFAULT}, $displayTimeValues );
 }
 
-# =========================
 =pod
----++ sub formatTime ($epochSeconds, $formatString, $outputTimeZone) ==> $value
+
+---++ formatTime ($epochSeconds, $formatString, $outputTimeZone) ==> $value
 | $epochSeconds | epochSecs GMT |
 | $formatString | twiki time date format |
 | $outputTimeZone | timezone to display. (not sure this will work)(gmtime or servertime) |
 
 =cut
-sub formatTime 
-{
+sub formatTime  {
     my ($epochSeconds, $formatString, $outputTimeZone) = @_;
     my $value = $epochSeconds;
 
@@ -2313,8 +1676,8 @@
         } else {
             #TODO:            $formatString = $formatString.  # TZD  = time zone designator (Z or +hh:mm or -hh:mm) 
         }
-    } 
-    
+    }
+
     $value = $formatString;
     $value =~ s/\$sec[o]?[n]?[d]?[s]?/sprintf("%.2u",$sec)/geoi;
     $value =~ s/\$min[u]?[t]?[e]?[s]?/sprintf("%.2u",$min)/geoi;
